/* as2.h   30 November 2001
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define LD 0		// op code number
#define ST 1
#define JMP 2
#define JAL 3
#define JR 4
#define ADD 5
#define SUB 6
#define MUL 7
#define DIV 8
#define AND 9
#define OR 10
#define XOR 11
#define SHL 12
#define SHR 13
#define TRAP 14

#define ABS 20		// addressing modes
#define DISP 21
#define INX 22
#define IMM 23
#define RR 24
#define RI 25
#define SP 26
#define NA 27

#define SYM 30		// type of symbol
#define NUM 31
#define OP 32
#define DOTA 33
#define DOTC 34
#define DOTW 35
#define DOTE 36

#define UNDEF 0x80000000	/* max neg int, denote undef in sym tab */

#define	MXBUF	200			/* max input line length */
#define MXMEM	5000		/* max no of token */

typedef struct { char type; char mode; int ref; int line; } token;

/* hash symbol table functions from hash.c */
int searchsym(char *s);
int putsym(char *s, int value);
int getsym(char *s);
void putvalue(int idx, int value);
int getvalue(int idx);
